import { useEffect, useRef } from 'react';
import { useController } from './useController';
function useListener(context, listener, listenWhen) {
    var controller = useController(context);
    var stateRef = useRef(controller.state);
    var emitState = function (newState) {
        listener(newState);
    };
    useEffect(function () {
        var subcription = controller.observable.subscribe(function (newState) {
            var state = stateRef.current;
            if (listenWhen) {
                if (listenWhen === null || listenWhen === void 0 ? void 0 : listenWhen(state, newState)) {
                    emitState(newState);
                }
            }
            else {
                emitState(newState);
            }
            stateRef.current = newState;
        });
        return function () {
            subcription.unsubscribe();
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [listenWhen, listener]);
    return controller;
}
export { useListener };
//# sourceMappingURL=useListener.js.map